/* Problem URL: https://codeforces.com/contest/2051/problem/E */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;

        vl a(n), b(n);
        cin >> a >> b;

        set<ll> set;
        repv(i, a) {
            set.insert(i);
        }
        repv(i, b) {
            set.insert(i);
        }

        sort(a.begin(), a.end(), greater<>());
        sort(b.begin(), b.end(), greater<>());

        ll ans = 0;
        repv(i, set) {
            int count = 0; 
            int not_negs = 0;

            int low = 0;
            int high = n - 1;
            while (low <= high) {
                int mid = (low + high) / 2;

                if (i <= b[mid]) {
                    count = mid + 1;
                    low = mid + 1;
                    continue;
                }

                high = mid - 1;
            }

            low = 0;
            high = n - 1;
            while (low <= high) {
                int mid = (low + high) / 2;

                if (i <= a[mid]) {
                    not_negs = mid + 1;
                    low = mid + 1;
                    continue;
                }

                high = mid - 1;
            }

            if (count - not_negs > k) {
                continue;
            }

            rmax(ans, i * count);
        }

        cout << ans << '\n';
    }
}
